using System;
using System.Collections;
using System.IO;
using System.Diagnostics;
using System.Text.RegularExpressions;
using System.Threading;

namespace CsCgrep
{
	/// <summary>
	/// grepsNXłB
	/// </summary>
	public class Cgrep
	{
		/// <summary>
		/// 啶̈Ⴂ𖳎邩ǂ
		/// </summary>
		private bool ignoreCase = true;

		/// <summary>
		/// }b`s̑O̕\s
		/// </summary>
		private int leadingLinesToPrint = 2;

		/// <summary>
		/// }b`š̕\s
		/// </summary>
		private int trailingLinesToPrint = 2;

		/// <summary>
		/// K\ǂ
		/// </summary>
		private bool isRegularExpression = false;

		/// <summary>
		/// }b`subN̊Ԃ̋󔒍s
		/// </summary>
		private int blankLinesBetweenBlocks = 1;

		/// <summary>
		/// Ōɏo͂sԍ
		/// </summary>
		private int lastPrintedLineNum = 0;

		// o͂ǂ
		private bool firstOutput = true;

        /// <summary>
        /// ̓t@C̃GR[fBO
        /// </summary>
        private string fileEncoding = Constants.SHIFT_JIS;


		public Cgrep()
		{
		}

		/// <summary>
		/// greps܂B
		/// </summary>
		/// <param name="fileName">t@C</param>
		/// <param name="pattern">p^[</param>
		/// <returns></returns>
		public ArrayList Grep(string fileName, string pattern)
		{
			// ʊi[Xg
			ArrayList result = new ArrayList();

			// [fBOReLXg
			ArrayList leadingContext = new ArrayList();

			// C
			int lineCount = 0;

			// c\s
			int remainingLinesToPrint = 0;

			// Ōɕ\sԍ
			lastPrintedLineNum = 0;


			// t@C̓IuWFNg
			StreamReader reader = null;

			// t@C1s
			string line = null;

			try
			{
				// t@C̓IuWFNg̍쐬
				reader = new StreamReader(
					fileName, System.Text.Encoding.GetEncoding(fileEncoding));

				while((line = reader.ReadLine()) != null)
				{
					lineCount++;

					if (MatchesSearchPattern(pattern, line))
					{
						if (firstOutput)
						{
							firstOutput = false;
						}
						else if ((lineCount - leadingContext.Count) > lastPrintedLineNum)
						{
							InsertBlankLines(ref result);
						}

						if (remainingLinesToPrint == 0)
						{
							PrintLeadingContext(pattern, fileName, lineCount,
								leadingContext, ref result);
						}

						PrintMatchLine(fileName, lineCount, line, ref result);

						if (trailingLinesToPrint > 0)
						{
							remainingLinesToPrint = trailingLinesToPrint;
						}
					}
					else if (remainingLinesToPrint > 0)
					{
						PrintLine(fileName, lineCount, line, ref result);

						remainingLinesToPrint--;
					}

					PushIntoLeadingContext(line, ref leadingContext);
				}
			}
			catch (ThreadAbortException e)
			{
				Debug.WriteLine("ThreadAbortException occured in Cgrep.Grep()");
				Debug.WriteLine(e.Message);
				Debug.WriteLine(e.StackTrace);
				
				Log log = Log.GetInstance();
				log.Error("ThreadAbortException occured in Cgrep.Grep()");
				log.Error(e.Message);
                if (e.InnerException != null)
                {
                    log.Error(e.InnerException.Message);
                }
				log.Error(e.StackTrace);
			}
			catch (Exception e)
			{
				Debug.WriteLine(e.Message);
				Debug.WriteLine(e.StackTrace);

				Log log = Log.GetInstance();
				log.Error(e.Message);
                if (e.InnerException != null)
                {
                    log.Error(e.InnerException.Message);
                }
				log.Error(e.StackTrace);

				MessageUtil.ShowAlert("t@C̓ǂݍݒɃG[܂B");
			}
			finally
			{
				if(reader != null)
				{
					// t@CN[Y
					reader.Close();
				}
			}

			return result;
		}

		/// <summary>
		/// ͍sp^[Ƀ}b`邩ǂԂ܂B
		/// </summary>
		/// <param name="pattern">p^[</param>
		/// <param name="line">͍s</param>
		/// <returns>}b`ꍇtrueAȂꍇfalse</returns>
		private bool MatchesSearchPattern(string pattern, string line)
		{
			if (isRegularExpression)
			{
				// p^[
				Regex ex = null;

				if (IgnoreCase)
				{
					ex = new Regex(pattern, RegexOptions.IgnoreCase);
				}
				else
				{
					ex = new Regex(pattern);
				}

				return ex.IsMatch(line);
			}
			else
			{
				if (IgnoreCase)
				{
					if (line.ToUpper().IndexOf(pattern.ToUpper()) != -1)
					{
						return true;
					}
					else
					{
						return false;
					}
				}
				else
				{
					if (line.IndexOf(pattern) != -1)
					{
						return true;
					}
					else
					{
						return false;
					}
				}
			}
		}

		/// <summary>
		/// ubNƃubN̊Ԃɋs܂B
		/// </summary>
		/// <param name="result"></param>
		private void InsertBlankLines(ref ArrayList result)
		{
			for (int i = 0; i < blankLinesBetweenBlocks; i++)
			{
				// ̌ʂi[
				SearchResult r = new SearchResult();
				result.Add(r);
			}
		}

		/// <summary>
		/// ʏs̏o͂܂B
		/// </summary>
		/// <param name="fileName">t@C</param>
		/// <param name="lineNum">sԍ</param>
		/// <param name="line">s̓e</param>
		/// <param name="result"></param>
		private void PrintLine(string fileName, int lineNum, string line, ref ArrayList result)
		{
			SearchResult r = new SearchResult();

			FileInfo fi = new FileInfo(fileName);
			r.FileName = fi.Name;
			r.Place = fi.DirectoryName;

			r.RowNumber = lineNum;
            r.Contents = line;

			result.Add(r);

			lastPrintedLineNum = lineNum;
		}

		/// <summary>
		/// }b`s̏o͂܂B
		/// </summary>
		/// <param name="fileName">t@C</param>
		/// <param name="lineNum">sԍ</param>
		/// <param name="line">s̓e</param>
		/// <param name="result"></param>
		private void PrintMatchLine(string fileName, int lineNum, string line, ref ArrayList result)
		{
			SearchResult r = new SearchResult();
			
			FileInfo fi = new FileInfo(fileName);
			r.FileName = fi.Name;
			r.Place = fi.DirectoryName;

			r.RowNumber = lineNum;
            r.Contents = line;
			r.IsMatchLine = true;

			result.Add(r);

			lastPrintedLineNum = lineNum;
		}

		/// <summary>
		/// [fBOReLXgɍsi[܂B
		/// </summary>
		/// <param name="line">s</param>
		/// <param name="leadingContext">[fBOReLXg</param>
		private void PushIntoLeadingContext(string line, ref ArrayList leadingContext)
		{
			if (LeadingLinesToPrint == 0)
			{
				return;
			}

			if (leadingContext.Count >= LeadingLinesToPrint)
			{
				leadingContext.RemoveAt(0);
			}

			leadingContext.Add(line);
		}

		/// <summary>
		/// [fBOReLXgo͂܂B
		/// </summary>
		/// <param name="pattern">p^[</param>
		/// <param name="fileName">t@C</param>
		/// <param name="currentLineNum">ݍs</param>
		/// <param name="leadingContext">[fBOReLXg</param>
		/// <param name="result"></param>
		private void PrintLeadingContext(string pattern, string fileName, int currentLineNum, ArrayList leadingContext, ref ArrayList result)
		{
			int lineNum = currentLineNum - leadingContext.Count;

			foreach (string line in leadingContext)
			{
				if (lineNum > lastPrintedLineNum)
				{
					if (MatchesSearchPattern(pattern, line))
					{
						PrintMatchLine(fileName, lineNum, line, ref result);
					}
					else
					{
						PrintLine(fileName, lineNum, line, ref result);
					}
				}

				lineNum++;
			}
		}

		/// <summary>
		/// 啶̈Ⴂ𖳎邩ǂ
		/// </summary>
		public bool IgnoreCase
		{
			get
			{
				return ignoreCase;
			}
			set
			{
				ignoreCase = value;
			}
		}

		/// <summary>
		/// }b`s̑O̕\s
		/// </summary>
		public int LeadingLinesToPrint
		{
			get
			{
				return leadingLinesToPrint;
			}
			set
			{
				leadingLinesToPrint = value;
			}
		}

		/// <summary>
		/// }b`š̕\s
		/// </summary>
		public int TrailingLinesToPrint
		{
			get
			{
				return trailingLinesToPrint;
			}
			set
			{
				trailingLinesToPrint = value;
			}
		}

		/// <summary>
		/// K\邩ǂ
		/// </summary>
		public bool IsRegularExpression
		{
			get
			{
				return isRegularExpression;
			}
			set
			{
				isRegularExpression = value;
			}
		}

		/// <summary>
		/// }b`subN̊Ԃ̋󔒍s
		/// </summary>
		public int BlankLinesBetweenBlocks
		{
			get
			{
				return blankLinesBetweenBlocks;
			}
			set
			{
				blankLinesBetweenBlocks = value;
			}
		}

        /// <summary>
        /// ̓t@C̃GR[fBO
        /// </summary>
        public string FileEncoding
        {
            get
            {
                return fileEncoding;
            }
            set
            {
                fileEncoding = value;
            }
        }
	}
}
