﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CsCgrep
{
    public partial class CharaCodeSettingDialog : Form
    {
        /// <summary>
        /// 親ウィンドウ
        /// </summary>
        private MainWindow parent;

        public CharaCodeSettingDialog(MainWindow parent)
        {
            InitializeComponent();

            this.parent = parent;

            // ファイル入力時のエンコーディングからラジオボタンの選択を設定
            switch (parent.AppSettings.InputEncoding)
            {
                case Constants.SHIFT_JIS:
                    inputSjisButton.Checked = true;
                    break;
                case Constants.UTF8:
                    inputUtf8Button.Checked = true;
                    break;
                case Constants.EUC:
                    inputEucButton.Checked = true;
                    break;
                default:
                    inputSjisButton.Checked = true;
                    break;
            }

            // ファイル出力時のエンコーディングからラジオボタンの選択を設定
            switch (parent.AppSettings.OutputEncoding)
            {
                case Constants.SHIFT_JIS:
                    outputSjisButton.Checked = true;
                    break;
                case Constants.UTF8:
                    outputUtf8Button.Checked = true;
                    break;
                case Constants.EUC:
                    outputEucButton.Checked = true;
                    break;
                default:
                    outputSjisButton.Checked = true;
                    break;
            }

        }

        /// <summary>
        /// キャンセルボタンが押された時の処理です。
        /// </summary>
        /// <param name="sender">イベントを発生させたオブジェクト</param>
        /// <param name="e">イベント</param>
        private void cancelButton_Click(object sender, EventArgs e)
        {
            Close();
        }

        /// <summary>
        /// OKボタンが押された時の処理です。
        /// </summary>
        /// <param name="sender">イベントを発生させたオブジェクト</param>
        /// <param name="e">イベント</param>
        private void okButton_Click(object sender, EventArgs e)
        {
            if (inputSjisButton.Checked)
            {
                parent.inputSjisMenuItem_Click(this, new EventArgs());
            }
            else if (inputUtf8Button.Checked)
            {
                parent.inputUtf8MenuItem_Click(this, new EventArgs());
            }
            else
            {
                parent.inputEucMenuItem_Click(this, new EventArgs());
            }

            if (outputSjisButton.Checked)
            {
                parent.outputSjisMenuItem_Click(this, new EventArgs());
            }
            else if (outputUtf8Button.Checked)
            {
                parent.outputUtf8MenuItem_Click(this, new EventArgs());
            }
            else
            {
                parent.outputEucMenuItem_Click(this, new EventArgs());
            }

            Close();
        }
    }
}
